from functools import lru_cache
import sys

# TODO: make this iterative
sys.setrecursionlimit(1000000)

@lru_cache(None)
def solve(r, c, p):
    assert r >= 1 and c >= 1
    if r == 1 and c == 1:
        return 0.0

    if r > c:
        return solve(c, r, p)

    if r == 1:
        # 1/2 chance we deal with the timer.
        # Timer can be any real value in (0, p)
        # \int_{x=0}^p x/p = p/2
        return (p / 4) + solve(r, c - 1, p)

    down = solve(r - 1, c, p)
    right = solve(r, c - 1, p)

    assert right <= down
    diff = down - right
    down_case = (-diff * diff / 2 / p) + down
    res = (right + down_case) / 2

    return res


def main():
    r, c, p = map(int, input().split())
    print(solve(r, c, p))


if __name__ == "__main__":
    main()
