def f(a, b):
    # how long in expectancy we wait if timer is in $[0, 1]$, one direction takes $a$ seconds and the other takes $b$ seconds?
    # $f(a, b) = \frac{1}{2} \int_0^1 \min(a, b + x) + \min(a + x,  b) dx$

    # WLOG $a \le b$
    if a > b:
        return f(b, a)

    # it can be shown that $|a - b| \le p$
    return (a + b) / 2 - (a - b) ** 2 / 4


n, m, p = map(int, input().split())

inf = 10.0**18
dp = [[0.0 for _ in range(m)] for __ in range(n)]

for i in range(n):
    for j in range(m):
        dp[i][j] = max(i, j) / 4 if i == 0 or j == 0 else f(dp[i - 1][j], dp[i][j - 1])

print(f"{p * dp[n-1][m-1]:.8f}")
